<!DOCTYPE html>
<html lang="en">
{% load staticfiles %}
<script src="{% static 'jquery/jquery-3.3.1.min.js' %}"></script>
<script src="{% static 'js/bootstrap.min.js' %}"></script>

<!-- jQuery Custom Scroller CDN -->
<script src="{% static 'js/jquery.mCustomScrollbar.js' %}"></script>
<script src="{% static 'js/jquery.mousewheel.min.js' %}"></script>
<!-- Bootstrap DateTimePicker js -->
<script src="{% static 'js/bootstrap-datepicker.min.js' %}"></script>
<script type="text/javascript" src="{% static 'js/moment.min.js' %}"></script>
<!-- DATATABLE JS -->
<script type="text/javascript" src="{% static 'js/jquery.dataTables.min.js' %}"></script>
<script type="text/javascript" src="{% static 'js/dataTables.bootstrap4.min.js' %}"></script>
<script type="text/javascript" src="{% static 'js/dataTables.buttons.min.js' %}"></script>
<script type="text/javascript" src="{% static 'js/buttons.bootstrap4.min.js' %}"></script>
<script type="text/javascript" src="{% static 'js/buttons.html5.min.js' %}"></script>
<script type="text/javascript" src="{% static 'js/dataTables.fixedHeader.min.js' %}"></script>
<!-- jquery validation plugin -->

<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	{% load staticfiles %}
    {% load i18n %}

	<title>{% trans 'Dashboard' %}</title>
	<!-- Bootstrap CSS CDN -->
	<link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}" type="text/css">
	<!-- Our Custom CSS -->
	<link rel="stylesheet" href="{% static 'css/fontawesome.all.css' %}">

	<!-- Scrollbar Custom CSS -->
	<!-- Font Awesome JS -->

	<!-- Bootstrap DateTimePicker css -->
</head>
<style>
.modal-body {
  overflow-x: auto;
}

</style>
<body>
<div></div>
<header class="header flex-row-sa-ct">
		<div class="ani-y-10">
			<h1 class="title-h1"></h1>
		</div>
	</header>
<link rel="stylesheet" href="{% static 'css/datatable-custom.css' %}" type="text/css">
	<div>
		<span>Account: {{request.user}}</span>
		{% if request.user.is_superuser %}&nbsp;
			<span>vip: <i class="far fa-check-square"></i></span>
		{% else %}
			<span>vip: <i class="far fa-square"></i></span>
		{% endif %} &nbsp;
		<button class="btn btn-primary btn-sm" onclick="javascript:location.href = '/logout/'">Logout</button>
	</div>
<button class="btn btn-primary btn-sm" id="topSearch">Top 3</button>
<button class="btn btn-primary btn-sm" onclick="javascript:location.href = '/outputSummary/'">Summary Output</button>
<br><br>
	<div class="row">
		<div class="col-xs-2 col-md-2">
			<select id="productSelect"  class="form-control custom-select">
				<option value="" selected disabled>Select product</option>
				{% for product in selectable_products %}
					<option value="{{product.id}}"> {{product.id}} </option>
				{% endfor %}
			</select>
		</div>
		<div class="col-xs-2 col-md-2">
			<input type="number" id="productNumber" min="1" class="form-control" placeholder="required product stock">
		</div>
		<div>
			<button id="addCourtBtn"><i class="fas fa-plus-circle"></i></button>
		</div>
	</div>
	<div id="container" class="content">
		<table id="productList" class="table table-striped table-hover dataTable no-footer" style="width:100%" role="grid">
			<thead>
			<tr>
				<th>Product ID</th>
				<th>{% trans 'stock_pcs' %}</th>
				<th>{% trans 'price' %}</th>
				<th>{% trans 'shop id' %}</th>
				<th>{% trans 'vip' %}</th>
			</tr>
			</thead>
			<tbody>
			{% for product in all_products %}
				<tr>
					<td >{{ product.id }}</td>
					<td id="{{product.id}}_stock">
						{{ product.stock_pcs }}
						{% if product.stock_pcs == 0 %}
							<span class="bg-danger text-white">out of stock</span>
						{% endif %}
					</td>
					<td>{{ product.price }}</td>
					<td>{{ product.shop_id.name }}</td>
					<td>
						{% if product.vip %}
							<i class="far fa-check-square"></i>
						{% else %}
							<i class="far fa-square"></i>
						{% endif %}
					</td>
				</tr>
			{% endfor %}
			</tbody>
		</table>
		<hr>
		<table id="orderList" class="table table-striped table-hover dataTable no-footer" style="width:100%" role="grid">
			<thead>
			<tr>
				<th>{% trans 'Order Id' %}</th>
				<th>{% trans 'product_id' %}</th>
				<th>{% trans 'qty' %}</th>
				<th>{% trans 'price' %}</th>
				<th>{% trans 'shop_id' %}</th>
				<th>{% trans 'Customer ID' %}</th>
				<th></th>
			</tr>
			</thead>
			<tbody>
			{% for order in all_orders %}
				<tr id="{{order.id}}">
					<td>{{ order.id }}</td>
					<td>{{ order.product_id.id }}</td>
					<td>{{ order.qty }}</td>
					<td>{{ order.product_id.price }}</td>
					<td>{{ order.shop_id.name }}</td>
					<td>{{ order.user_id.id }}</td>
					<td><button onclick="removeOrder('{{ order.id }}')"><i class="fas fa-minus-circle"></i></button></td>
				</tr>
			{% endfor %}
			</tbody>
		</table>
	</div>
<div class="modal fade" id="topSearchModal" tabindex="-1" role="dialog" aria-labelledby="topSearchModalTitle"
	 aria-hidden="true" data-backdrop="static">
	<div class="modal-dialog modal-xl modal-dialog-centered" role="document">
		<div class="modal-content">
			<div class="modal-header">
				<h5 class="modal-title" id="topSearchModalTitle">{% trans 'Top 3 Products' %}</h5>
				<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					<span aria-hidden="true">&times;</span>
				</button>
			</div>
			<div class="modal-body" style="margin: auto">
				<div class="form-group md-10" id="topSearchModalBody">
				</div>
			</div>
			<div class="modal-footer">
				<button type="button" id="registerCancelBtn" class="btn btn-default" style="border: 1px solid #666666" data-dismiss="modal">{% trans 'OK' %}</button>
			</div>
		</div>
	</div>
</div>
<p id="product_summary" hidden>{{product_summary|safe}}</p>
</body>
</html>
<script>
	var result_notification = [];
	var empty_notification = [];
	var summary = JSON.parse(document.getElementById('product_summary').textContent);
	setInterval(function(){
			refresh();
        }, 3000);
    var product_table = $('#productList').DataTable({
		"scrollY": true,
		"scrollCollapse": true,
	    "bPaginate": true,
        "bLengthChange": false,
        "bFilter": true,
        "bInfo": false,
        "bAutoWidth": false,
        "pageLength": 5,
		fixedHeader: {
			header: true
		}
    });
    var product_table = $('#orderList').DataTable({
		"scrollY": true,
		"scrollCollapse": true,
	    "bPaginate": true,
        "bLengthChange": false,
        "bFilter": true,
        "bInfo": false,
        "bAutoWidth": false,
        "pageLength": 5,
		fixedHeader: {
			header: true
		}
    });
	$('#addCourtBtn').on('click',function(){
		$.ajax({
			url : '/addProductToCourt/',
			method : 'POST',
			data : {
				csrfmiddlewaretoken : '{{ csrf_token }}',
				product_id : $('#productSelect').val(),
				product_stock : $('#productNumber').val(),
			},
			error : function(e) {
				console.log(e)
				alert(e.responseJSON.errorMessage)
			},
			success : function(data){
				window.location.href = '/';
			}
		});
	});
	function removeOrder(order_id){
		var confirm_remove = confirm("Are you sure to remove Num." + order_id + " order?")
		if (confirm_remove){
			$.ajax({
				url : '/removeOrder/',
				method : 'POST',
				data : {
					csrfmiddlewaretoken : '{{ csrf_token }}',
					order_id : order_id,
				},
				error : function(e) {
					console.log(e)
					alert(e.responseJSON.errorMessage)
				},
				success : function(data){
					window.location.href = '/';
				}
			});
		}
	}
	$('#topSearch').on('click', function(){
		$.ajax({
			url : '/topSearch/',
			method : 'POST',
			data : {
				csrfmiddlewaretoken : '{{ csrf_token }}'
			},
			error : function(e) {
				console.log(e)
				alert(e.responseJSON.errorMessage)
			},
			success : function(data){
				$('#topSearchModalBody').html(data);
				$('#topSearchModal').modal('show');
			}
		});
	})
	function refresh(){
		$.ajax({
			url : '/refresh/',
			method : 'GET',
			error : function(e) {
				alert(e.responseJSON.errorMessage)
			},
			success : function(data){
				refresh_summary = JSON.parse(data.product_summary)
				refresh_summary.forEach(function (element){
					if (element.fields.stock_pcs != summary[element.pk-1].fields.stock_pcs){
						if (summary[element.pk-1].fields.stock_pcs == 0){
							var empty_count = empty_notification.push(element.pk)
							result_notification.push(element.pk)
						}else{
							var count = result_notification.push(element.pk)
						}
					}
					notification = "";
					if (count || empty_count){
						if (empty_count){
							alert("product of: " + empty_notification.join(", ") + " is arrived.")
						}
						result_notification.forEach(function (temp_id){
							$('#'+temp_id+"_stock").text(refresh_summary[temp_id-1].fields.stock_pcs)
						});
						summary = refresh_summary
					}
				})
			}
		});
	}
</script>